/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.accessor;

import java.util.List;

import com.sigpwned.jsonification.accessor.processing.AllIndexes;
import com.sigpwned.jsonification.accessor.processing.RangeIndexes;
import com.sigpwned.jsonification.accessor.processing.SingleIndexes;

public interface AccessorProcessor {
	public static abstract class Indexes {
		public AllIndexes asAll() {
			return (AllIndexes) this;
		}

		public RangeIndexes asRange() {
			return (RangeIndexes) this;
		}

		public SingleIndexes asSingle() {
			return (SingleIndexes) this;
		}
	}
	
	public void beginAccessor();
	
	public void endAccessor();
	
	public void objectAccess(List<String> names);
	
	public void arrayAccess(Indexes indexes);
}
