/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.accessor.reference;

import java.util.Arrays;
import java.util.List;

import com.sigpwned.jsonification.Accessor;
import com.sigpwned.jsonification.accessor.x.JsonNotAnLValueException;
import com.sigpwned.jsonification.model.JsonValue;

public class IdentityJsonReference extends AbstractJsonReference {
	public IdentityJsonReference() {
	}

	public List<JsonValue> get(JsonValue root) {
		return Arrays.asList(root);
	}

	public void update(JsonValue root, Accessor.Function transformation) {
		throw new JsonNotAnLValueException(root);
	}

	public void append(StringBuilder buf) {
	}

	public Multiplicity getMultiplicity() {
		return Multiplicity.ONE;
	}
}
