/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.accessor.x;

import com.sigpwned.jsonification.accessor.JsonAccessorEvalException;
import com.sigpwned.jsonification.model.JsonList;

public class InvalidListJsonAccessorEvalException extends JsonAccessorEvalException {
	private static final long serialVersionUID = 2761189782423226945L;

	private JsonList list;
	private int index;

	public InvalidListJsonAccessorEvalException(JsonList list, int index) {
		super("JsonList too small for accessor (no such index: "+index+")");
	}

	public JsonList getList() {
		return list;
	}

	public int getIndex() {
		return index;
	}
}
