/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.accessor.x;

import com.sigpwned.jsonification.accessor.JsonAccessorEvalException;
import com.sigpwned.jsonification.model.JsonValue;

public class JsonNotAnLValueException extends JsonAccessorEvalException {
	private static final long serialVersionUID = 7198371185245784923L;
	
	private JsonValue value;

	public JsonNotAnLValueException(JsonValue value) {
		super("Not an l-value: "+value+" (can't set with Accessor)");
		this.value = value;
	}
	
	public JsonValue getValue() {
		return value;
	}
}
