/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.manipulation.build.processing.coordinates;

import com.sigpwned.jsonification.JsonProcessor.Coordinate;
import com.sigpwned.jsonification.manipulation.build.processing.CoordinateFactory;
import com.sigpwned.jsonification.manipulation.build.processing.ScopeType;
import com.sigpwned.jsonification.manipulation.build.x.IllegalEventJsonBuildingException;

public class TopCoordinateFactory extends CoordinateFactory {
	public TopCoordinateFactory() {
        super(false);
    }

    @Override
	public void primeCoordinate(Object value) {
		throw new IllegalEventJsonBuildingException("Cannot prime coordinates when no scopes are open (value="+value+")");
	}

	@Override
	public Coordinate currentCoordinate() {
		return null;
	}

	@Override
	public Coordinate nextCoordinate(Object value) {
		if(value != null)
			throw new IllegalEventJsonBuildingException("Cannot specify coordinate when no scopes are open (value="+value+")");
		return null;
	}

    @Override
    public ScopeType getScopeType() {
        return null;
    }

    @Override
    public String getScopeTypeName() {
        return "TOP";
    }
}