/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.model;

import java.util.Iterator;
import java.util.ListIterator;

public interface JsonList extends JsonValue, Iterable<JsonValue> {
	public int size();
	
	public boolean isEmpty();
	
	public void add(JsonValue value);
	
	public void addAll(JsonList values);
	
	public void clear();
	
	public JsonValue remove(int index);
	
	public JsonValue get(int index);
	
	public JsonValue set(int index, JsonValue value);
	
	public ListIterator<JsonValue> listIterator();
	
	public ListIterator<JsonValue> listIterator(int index);
	
	public Iterator<JsonValue> iterator();
}
