/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.model;

import java.util.List;

import com.sigpwned.jsonification.Accessor;

public interface JsonValue {
	public JsonInt asInt();
	
	public JsonFloat asFloat();
	
	public JsonNumber asNumber();
	
	public JsonString asString();
	
	public JsonBoolean asBoolean();
	
	public JsonObject asObject();
	
	public JsonList asList();
	
    public List<JsonValue> readMany(Accessor accessor);

    public List<JsonValue> readMany(String accessor);
    
    public JsonValue readOne(Accessor accessor);

    public JsonValue readOne(String accessor);
    
    public void writeMany(Accessor accessor, Accessor.Function transformation);

    public void writeMany(Accessor accessor, Accessor.Function transformation, boolean failureAcceptable);

    public void writeOne(Accessor accessor, JsonValue value);
    
    public void writeOne(Accessor accessor, Accessor.Function transformation);

    public void writeOne(Accessor accessor, Accessor.Function transformation, boolean failureAcceptable);
}
