/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.model.impl;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Set;

import com.sigpwned.jsonification.Accessor;
import com.sigpwned.jsonification.Accessor.Function;
import com.sigpwned.jsonification.model.JsonBoolean;
import com.sigpwned.jsonification.model.JsonFloat;
import com.sigpwned.jsonification.model.JsonInt;
import com.sigpwned.jsonification.model.JsonList;
import com.sigpwned.jsonification.model.JsonNull;
import com.sigpwned.jsonification.model.JsonNumber;
import com.sigpwned.jsonification.model.JsonObject;
import com.sigpwned.jsonification.model.JsonString;
import com.sigpwned.jsonification.model.JsonValue;
import com.sigpwned.jsonification.model.x.NullPointerJsonException;

public class JsonNullImpl implements JsonNull {
	public static final JsonNull NULL=new JsonNullImpl();
	
	private JsonNullImpl() {
	}
	
	public boolean booleanVal() {
		throw new NullPointerJsonException();
	}
	public JsonInt asInt() {
		return this;
	}
	public JsonFloat asFloat() {
		return this;
	}
	public JsonNumber asNumber() {
		return this;
	}

	public JsonString asString() {
		return this;
	}

	public JsonBoolean asBoolean() {
		return this;
	}

	public JsonObject asObject() {
		return this;
	}

	public JsonList asList() {
		return this;
	}

	public byte byteVal() {
		throw new NullPointerJsonException();
	}

	public short shortVal() {
		throw new NullPointerJsonException();
	}

	public int intVal() {
		throw new NullPointerJsonException();
	}

	public long longVal() {
		throw new NullPointerJsonException();
	}

	public float floatVal() {
		throw new NullPointerJsonException();
	}

	public double doubleVal() {
		throw new NullPointerJsonException();
	}

	public Set<String> keySet() {
		throw new NullPointerJsonException();
	}

	public Collection<JsonValue> values() {
		throw new NullPointerJsonException();
	}

	public boolean containsKey(String name) {
		throw new NullPointerJsonException();
	}

	public int size() {
		throw new NullPointerJsonException();
	}

	public boolean isEmpty() {
		throw new NullPointerJsonException();
	}

	public JsonValue get(String name) {
		throw new NullPointerJsonException();
	}

	public JsonValue get(String name, JsonValue defaultValue) {
		throw new NullPointerJsonException();
	}

	public JsonValue put(String name, JsonValue value) {
		throw new NullPointerJsonException();
	}

	public JsonValue remove(String name) {
		throw new NullPointerJsonException();
	}

	public void putAll(JsonObject other) {
		throw new NullPointerJsonException();
	}

	public String stringVal() {
		throw new NullPointerJsonException();
	}

	public void add(JsonValue value) {
		throw new NullPointerJsonException();
	}

	public void addAll(JsonList values) {
		throw new NullPointerJsonException();
	}

	public void clear() {
		throw new NullPointerJsonException();
	}

	public JsonValue remove(int index) {
		throw new NullPointerJsonException();
	}

	public JsonValue get(int index) {
		throw new NullPointerJsonException();
	}

	public JsonValue set(int index, JsonValue value) {
		throw new NullPointerJsonException();
	}

	public ListIterator<JsonValue> listIterator() {
		throw new NullPointerJsonException();
	}

	public ListIterator<JsonValue> listIterator(int index) {
		throw new NullPointerJsonException();
	}

	public Iterator<JsonValue> iterator() {
		throw new NullPointerJsonException();
	}

	public OriginalType getOriginalType() {
        throw new NullPointerJsonException();
	}

    public List<JsonValue> readMany(Accessor accessor) {
        throw new NullPointerJsonException();
    }

    public List<JsonValue> readMany(String accessor) {
        throw new NullPointerJsonException();
    }

    public JsonValue readOne(Accessor accessor) {
        throw new NullPointerJsonException();
    }

    public JsonValue readOne(String accessor) {
        throw new NullPointerJsonException();
    }

    public void writeMany(Accessor accessor, Function transformation) {
        throw new NullPointerJsonException();
        
    }

    public void writeMany(Accessor accessor, Function transformation, boolean failureAcceptable) {
        throw new NullPointerJsonException();
    }

    public void writeOne(Accessor accessor, JsonValue value) {
        throw new NullPointerJsonException();
    }

    public void writeOne(Accessor accessor, Function transformation) {
        throw new NullPointerJsonException();
    }

    public void writeOne(Accessor accessor, Function transformation, boolean failureAcceptable) {
        throw new NullPointerJsonException();
    }
}
