/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.model.x;

import com.sigpwned.jsonification.model.JsonRuntimeException;
import com.sigpwned.jsonification.model.JsonValue;

public class ClassCastJsonException extends JsonRuntimeException {
	private static final long serialVersionUID = -878099840218851870L;
	
	private Class<? extends JsonValue> expectedType;	
	private JsonValue value;

	public ClassCastJsonException(Class<? extends JsonValue> expectedType, JsonValue value) {
		super("Expected value of type `"+expectedType.getSimpleName()+"'; got "+value);
		this.expectedType = expectedType;
		this.value = value;
	}

	public Class<? extends JsonValue> getExpectedType() {
		return expectedType;
	}

	public JsonValue getValue() {
		return value;
	}
}
