/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.serialization;

import com.sigpwned.jsonification.serialization.serialize.approach.AncestorTypeJsonSerializeApproach;
import com.sigpwned.jsonification.serialization.serialize.approach.BeanJsonSerializeApproach;
import com.sigpwned.jsonification.serialization.serialize.approach.ExactTypeJsonSerializeApproach;
import com.sigpwned.jsonification.serialization.serialize.approach.InterfaceTypeJsonSerializeApproach;
import com.sigpwned.jsonification.serialization.serialize.approach.JsonValueJsonSerializeApproach;
import com.sigpwned.jsonification.serialization.serialize.approach.NullJsonSerializeApproach;
import com.sigpwned.jsonification.serialization.serialize.approach.ToJsonMethodJsonSerializeApproach;


public class DefaultJsonSerializer extends AbstractJsonSerializer {
	public DefaultJsonSerializer() {
        addSerializeApproach(new NullJsonSerializeApproach());
        addSerializeApproach(new JsonValueJsonSerializeApproach());
        addSerializeApproach(new ExactTypeJsonSerializeApproach());
        addSerializeApproach(new ToJsonMethodJsonSerializeApproach());
        addSerializeApproach(new AncestorTypeJsonSerializeApproach());
        addSerializeApproach(new InterfaceTypeJsonSerializeApproach());
        addSerializeApproach(new BeanJsonSerializeApproach());
	}
}
