/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.serialization;

import java.lang.reflect.Method;
import java.util.Collection;

public class JsonSerialization {
	protected static String capitalizeFirstLetter(String name) {
		return name.substring(0, 1).toUpperCase()+name.substring(1);
	}
	
	protected static Method findMethod(Class<?> type, Class<?> resultType, Collection<String> names, Class<?>... argumentTypes) {
		Method result=null;
		for(Method m : type.getMethods())
			if(names.contains(m.getName()))
				if(m.getParameterTypes().length == argumentTypes.length) {
					boolean acceptable;
					if(resultType != null) {
						if(resultType.isAssignableFrom(m.getReturnType()))
							acceptable = true;
						else
							acceptable = false;
					}
					else {
						if(m.getReturnType().equals(void.class) || m.getReturnType().equals(Void.class))
							acceptable = true;
						else
							acceptable = false;
					}
					
					if(acceptable) {
						result = m;
						break;
					}
				}
		return result;
	}
}
