/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.serialization.serialize;

import java.io.IOException;

import com.sigpwned.jsonification.serialization.JsonSerialization;

public abstract class JsonTypeSerializer<T> extends JsonSerialization {
	private Class<T> serializedType;
	
	public JsonTypeSerializer(Class<T> serializedClass) {
		this.serializedType = serializedClass;
	}

	public Class<T> getSerializedType() {
		return serializedType;
	}
	
	public abstract boolean serialize(Object value) throws IOException;
}
