/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.serialization.serialize.approach;


import java.io.IOException;

import com.sigpwned.jsonification.JsonSerializer;
import com.sigpwned.jsonification.manipulation.JsonFragmentBuilder;
import com.sigpwned.jsonification.serialization.serialize.JsonSerializeApproach;
import com.sigpwned.jsonification.serialization.serialize.JsonTypeSerializer;

public class InterfaceTypeJsonSerializeApproach extends JsonSerializeApproach {
	public boolean serialize(JsonSerializer serializer, JsonFragmentBuilder builder, Object value) throws IOException {
		boolean result;

		result = false;
		for(Class<?> iface : value.getClass().getInterfaces()) {
			if(serializer.hasTypeSerializer(iface)) {
				JsonTypeSerializer<?> typeSerializer=serializer.getTypeSerializer(iface);
				result = typeSerializer.serialize(value);
				if(result)
					break;
			}
		}
		
		return result;	
	}
}
