/*
 * Copyright 2013 Andy Boothe
 * 
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 * 
 *        http://www.apache.org/licenses/LICENSE-2.0
 * 
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
package com.sigpwned.jsonification.util;

import java.io.IOException;

import com.sigpwned.jsonification.JsonProcessor;

public abstract class AbstractJsonProcessor<T> implements JsonProcessor<T> {
	public void beginJson() throws IOException {
	}

	public T endJson() throws IOException {
		return null;
	}

	public void beginObject(Coordinate coordinate) throws IOException {
	}

	public void endObject() throws IOException {
	}

	public void beginList(Coordinate coordinate) throws IOException {
	}

	public void endList() throws IOException {
	}

	public void value(Coordinate coordinate, boolean value) throws IOException {
	}

	public void value(Coordinate coordinate, long value) throws IOException {
	}

	public void value(Coordinate coordinate, double value) throws IOException {
	}

	public void value(Coordinate coordinate, String value) throws IOException {
	}

	public void nullValue(Coordinate coordinate) throws IOException {
	}
}
